\documentclass[12pt,a4paper]{article}
\usepackage[nolists,nomarkers]{endfloat}
%\usepackage[english]{babel}
\usepackage{textcomp}
\usepackage[utf8x]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{color}
\usepackage{graphicx}
\usepackage{chngpage}
\usepackage{ifthen}
\usepackage{gitinfo}
%\enabledraftstandard
\usepackage[hidelinks]{hyperref}
\usepackage{url}
\usepackage{breakurl}
\usepackage{xcolor,soul,lipsum}
\usepackage{lineno}
%\usepackage{adjustbox}
%\usepackage{fancyvrb}
%\usepackage{verbatim}
\usepackage{rotating}
\usepackage{listings}

\newcommand{\myul}[1]{\ul{#1}}

%% \usepackage[firstpage]{draftwatermark}
%% %\SetWatermarkText{ENTWURF}
%% \SetWatermarkText{DRAFT}
%% \SetWatermarkScale{4}
%% \SetWatermarkAngle{50}
%% \SetWatermarkLightness{0.90}

\sloppy
%\hoffset-3mm
\parindent0mm

\newcommand{\da}{DA}
\newcommand{\sa}{SA}
\newcommand{\ecs}{ECS}
\newcommand{\ilias}{ILIAS}
\newcommand{\cces}{\texttt{cc/enrolment\_status\ }}
\newcommand{\ccms}{\texttt{cc/member\_status\ }}
\newcommand{\button}[1]{\fbox{\texttt{#1}}}
\newcommand{\jsToAppletComUrlA}{\mbox{http://stackoverflow.com/questions/7278626/javascript-to-java-applet-communication}}
\newcommand{\jsToAppletComUrlB}{\mbox{http://docs.oracle.com/javase/tutorial/deployment/applet/invokingAppletMethodsFromJavaScript.html}}
\newcommand{\appletToDom}{\mbox{http://docs.oracle.com/javase/tutorial/deployment/applet/manipulatingDOMFromApplet.html}}

\lstset{basicstyle=\ttfamily}
\newcommand{\includecode}[2][{}]{\lstinputlisting[numbers=left, numberstyle=\tiny, stepnumber=1, numbersep=5pt, breaklines, breakatwhitespace, linewidth=1.1\textheight, xleftmargin=1cm, language=#1]{#2}}

\newcommand{\texta}{}
\newcommand{\textb}{}
\newcommand{\textc}{}
\newcommand{\textd}{}
\newcommand{\texte}{}
\newcommand{\textf}{}

% \linenumbers

\DeclareDelayedFloatFlavor{sidewaysfigure}{figure}

\begin{document}
\title{Mahara/Moodle member status}
\author{David Boehringer\\Universit\"at Stuttgart \and Heiko Bernl\"ohr\\FreeIT.de}
\maketitle
\thispagestyle{empty}
\begin{center}
%  Version: 2.0
  Version: \gitVtag\\
%  Commit-id: \gitAbbrevHash
\end{center}
\begin{abstract}
New ECS resource providing enrolment status for users enroled to
external courses (via courselinks). The course providing participant (e.g.
Moodle) informs the courselink providing participant of the subscribed user
(e.g. Mahara) about every change of its enrolment status in the course.
This paper only concerns about informing a courselink providing system about
status changes of their users consuming a course on a course providing system.
As Stefan Meyer (ILIAS, Leifos) has noticed, this resource could also be used
to inform about status of some more resources, e.g. ILIAS groups. In order to
respect this we have generalized our naming of the resource name from \cces to
\ccms and also the used attribute names. But all other details, especially the
sequence diagrams and state chart only focus on courselinks and courses.
Further we use Mahara as a courselink and Moodle as a course providing system.
Of course these systems could be substituded by other system types.
\end{abstract}

%\vspace{\fill}
%\begin{center}
%\includegraphics[scale=1.0]{vip_lms}
%\end{center}
%\vspace{\fill}
%
\newpage

\section{Member status}

The \ccms resource describes an enrolment status of a
remotly subscribed user (via courselinks) to a course. This document supersedes
the part
\begin{quote}
  {\bf Moodle}\\
  1. New enrolmentStatus resource
\end{quote}
in \cite{specBoehMaharaMoodle}.

\subsection{Events\label{events}}
\newcommand{\rstat}[1]{return status: #1}
For the following event considerations please have always the state chart on
page \pageref{state:enrolmentStatus} in mind.\medskip

Moodle has to send the user enrolment status to Mahara on these events:
\begin{description}
  \item[first time clicking courselink] A user clicks on a courselink on Mahara
    for the first time and tries to consume the linked course on Moodle (sequence
    diagram on page \pageref{seq:initialEnrolmentStatus}).\\
    \rstat{active | pending }
  \item[reject] User will be rejected by course or system admin. This could only happen
    in \textit{pending} state, e.g. user was on a waiting list, but had not been
    accepted for the course.\\
    \rstat{rejected}
  \item[subscribe] User will be subcribed to course (leaving waiting list). Now
    he is able to access and consume the course.\\
    \rstat{active}
  \item[waiting list] User will be transfered to waiting list
    i.e. he can't access and consume the course yet. He has to wait until
    he will be subscribed to the course.\\
    \rstat{pending}
  \item[unsubscribe] User ended course membership himself or his course
    membership has been terminated by course administrator or system
    administrator. To access and consume the course again he has to enrole
    again.\\
    \rstat{unsubscribed}
  \item[disable subscription] User is disabled by course or system
    administrator, i.e. he is (temporarly) not allowed to access course for
    whatever reason.\\
    \rstat{denied}
  \item[enable subscription] User is enabled by course or system administrator,
    i.e. he is to be allowed to access course again.\\
    \rstat{active}
  \item[delete user account] User account on remote system is deleted. \ccms
    has to be sent for all of the user's course memberships.\\
    \rstat{unsubscribed}
  \item[deactivate user account] User account on remote system is deactivated.\\
    \rstat{inactive\_account}
  \item[activate user account] User account on remote system is activated.\\
    \rstat{active | pending | denied}
  \item[subsequently clicking courselink] A user subsequently clicks a
    courselink on Mahara and consumes an already enroled course on Moodle (see
    page \pageref{seq:subsequentEnrolmentStatus}).  After this event Moodle has
    to send the current enrolment status.  This also guarantees to have a
    status even if Mahara just forget/loose\footnote{We don't make the resource
    persistent,  so loosing the status somehow on Mahara it will be refreshed
    after next click on a courselink.} it somehow.\\
    \rstat{pending | active | denied }
\end{description}

\subsection{Status values\label{statusValues}}
\newcommand{\statusnotstored}{This status is usually not persistently stored in the LMS.}
For the following status considerations please have always the state chart on
page \pageref{state:enrolmentStatus} in mind.\medskip

The status attribute could have following values:
\begin{description}
  \item[active] User is enroled and allowed to consume the course.
  \item[pending] User enroled for the course, but is on a waiting list.
  \item[rejected] User is not on waiting list anymore\footnote{Clicking the courselink
    again the user will get through initial enrolment as described in sequence
    diagram on page \pageref{seq:initialEnrolmentStatus}.}. \statusnotstored
  \item[unsubscribed] User is not enroled
    anymore\addtocounter{footnote}{-1}\footnotemark. \statusnotstored
  \item[denied] Still enroled but not allowed to access the course.
  \item[inactive\_account] Still enroled but temporarly not allowed to access
    the system. 
\end{description}
Whereas only \texttt{active, pending, rejected} and \texttt{inactive\_account}
status values have to be stored/saved on the LMS. All others are only generated
while the transitions. 

\subsection{Redirect querystring parameters\label{subsec:redirect_querystring_parameters}}

Our present specification of redirecting a user is defined in
\cite{specRedirectProcedure} and the procedure how to compute the redirect hash
(for securing the redirect parameters) in \cite{specHashComputing}. As
described in the document \cite{specBoehMaharaMoodle} Moodle has to provide an
interface to define for each participant and its community participation what
personal data should be appended as query strings. Of course to allow this we
have to enhance our specs in \cite{specRedirectProcedure} and
\cite{specHashComputing}.\medskip

In order to be backward compatible we have to consider four use cases.

\subsubsection{New system behaving as a courselink providing system in legacy mode}
Only provide the query strings defined in \cite{specRedirectProcedure}. This
would be possible by selecting/configuring the necessary querystring parameters
per participant through LMS admin (there are mockups for the admin interface in
\cite{moodleECSmockups}).  Concatenate the courselink-url value and the values
of ecs\_login, ecs\_firstname, ecs\_lastname, ecs\_email, ecs\_institution,
ecs\_uid as described in \cite{specHashComputing}.

\subsubsection{New system behaving as a course providing system in legacy mode}
If there is no \texttt{ecs\_person\_id\_type} query string parameter present,
just behave like a legacy system
\cite{specRedirectProcedure}\cite{specHashComputing}.

\subsubsection{New system behaving as a courselink providing system in none legacy mode}
Just construct the whole url-encoded Redirect-URL (Location header) with all
query string parameters specified in \cite{specRedirectProcedure} and all new
query string parameters preselected through admin interface
\cite{moodleECSmockups} and the \texttt{ecs\_person\_id\_type} parameter
representing the type to be used for authentication and compute the sha1 hash
(there is no special order of querystring parameters), e.g.:
\begin{quote}
  \url{https://ilias.uni-stuttgart.de/goto.php?target=crs_95034&client_id=USTGT?ecs_login=DD12345&ecs_firstname=Dagobert&ecs_lastname=Duck&ecs_email=Dagobert.Duck@cashstore-ag.com&ecs_institution=Cachestore%20AG&ecs_uid=il_0_usr_13492&ecs_eppn=dummy1&ecs_PersonalUniqueCode=dummy2&ecs_person_id_type=ecs_eppn}
\begin{verbatim}
echo -n "https://ilias.uni ... =ecs_eppn" | sha1sum -
  => 616fea7942c7754de1c72e4eb3983dc7a7e37412
\end{verbatim}
\end{quote}
Create a new \texttt{/sys/auths} representation with the previously computed
message digest value assigned to \texttt{realm} parameter and append the
returned hash value to form the final redirect url, e.g.:
\begin{quote}
  \url{https://ilias.uni-stuttgart.de/goto.php?target=crs_95034&client_id=USTGT?ecs_login=DD12345&ecs_firstname=Dagobert&ecs_lastname=Duck&ecs_email=Dagobert.Duck@cashstore-ag.com&ecs_institution=Cachestore%20AG&ecs_uid=il_0_usr_13492&ecs_eppn=dummy1&ecs_PersonalUniqueCode=dummy2&ecs_person_id_type=ecs_eppn&ecs_hash=6ebdec99bda94710b2df529a19ad34689796fcfe}
\end{quote}

\subsubsection{New system behaving as a course providing system in none legacy
mode}
If there is a \texttt{ecs\_person\_id\_type} query string parameter present
then operate in none legacy mode: Check \texttt{ecs\_hash} query string against
\texttt{/sys/auths}. If the hash is unvalid the caller will be rejected
otherwise caller will be considered authorized. Further check sha1 message
digest provided by \texttt{realm} attribute from the authorization token
against the sha1sum of the recomputetd request URL (pruned off from
\texttt{ecs\_hash} parameter and its value before sha1 digest computation). The
check has to be done on a url encoded request URL.

\begin{figure}[p]
  \vspace*{-1cm}\includegraphics[scale=0.8]{enrolment_status_seq}
  \caption{\label{seq:initialEnrolmentStatus}Sending enrolment status after
  consuming a courselink for the first time. For \textit{params} in
  the \textit{redirect} of the \textit{consume courselink} block  see
  \ref{subsec:redirect_querystring_parameters} at page
  \pageref{subsec:redirect_querystring_parameters}.}
\end{figure}

\begin{figure}[p]
  \includegraphics[scale=0.8]{subsequent_enrolment_status_seq}
  \caption{\label{seq:subsequentEnrolmentStatus}Sending enrolment status
  after subsequently consuming a courselink.}
\end{figure}

\begin{figure}[p]
  \centering
  \includegraphics[scale=0.5]{enrolment_status_state}
  \caption{\label{state:enrolmentStatus}UML state diagram. Enrolment status of
  a user in respect to a course on a LMS. For event description see
  \ref{events} on page \pageref{events}. For status values description see
  \ref{statusValues} on page \pageref{statusValues}.} 
\end{figure}


\subsection{Resource attributes}

For the json schema of \ccms see page \pageref{schema:member_status}.
Following description write on \ccms resource attributes for which a user
status has changed or asked for:
\begin{description}
  \item[id] It's a unique course id on the course providing system. It
    references the same course as \texttt{url}. It should be used as a unique id.
  \item[url] It's a url transfering a courselink consuming user
    directly to the course on the course providing system. It references the
    same course as \texttt{id}. It could be used as a unique id.
  \item[personID] Unique id of the course consuming user.
  \item[personIDtype] Class/type of \texttt{personID}. It's a controlled
    vocabulary (see page \pageref{schema:member_status} for possible
    values).
  \item[status] Status of the user's course enrolment. It's a controlled
    vocabulary (for possible values see schema on page
    \pageref{schema:member_status} and values descriptions at
    \ref{statusValues}).
\end{description}

\subsection{PersonID types}

\begin{description}
  \item[ecs\_ePPN] EduPersonPrincipalName as defined in \cite{eppn}
  \item[ecs\_loginUID] Organization wide user id (uid in university context).
    Usually this would be the string in front of the `@' of the ePPN.
  \item[ecs\_login] Login name on course providing system (e.g. LMS). Only unique
    in connection with the LMS.
  \item[ecs\_uid] Internal user id on course providing system (e.g. LMS). Only unique
      in connection with the LMS.
  \item[ecs\_email] Email address.
  \item[ecs\_PersonalUniqueCode] SchacPersonalUniqueCode (matriculation number)
    as defined in \cite{SchacPersonalUniqueCode}. Should be used as values in
    order to be internationally compatible.
  \item[ecs\_custom] For local customized person id type.
\end{description}

Across institutions a person identifying attribute should be used that is also
used in context of eduGAIN interfederations such as `eduPersonPrincipalName'
(ePPN); see eduGAIN Policy Framework Attribute Profile, p. 4.\medskip 

Often these attributes are not used yet, but in context of eduGAIN federations
(e.g. using Shibboleth) they are meant to be used to identify a remote user.
Directory services or IdPs should be able to provide such a unique person
identifying attribute. If they can, it must be stored as person data in the
LMS. If necessary, the LMS has to be adapted to store such an attribute that is
different from the UID of the user in his institution. Since the attributes are
needed for eduGAIN compatibility of an LMS it is recommended that this is
included in the core of the system and not as part of a plugin.

\begin{sidewaysfigure}
    \includecode{cc_member_status.schema.json}
    \caption{JSON-Schema definition of member\_status resource}
    \label{schema:member_status}
\end{sidewaysfigure}

\begin{thebibliography}{99}
\bibitem{specRedirectProcedure}  FreeIT.de, ECSA Documentation, \textit{Redirect protocol when consuming courselinks}, \url{http://freeit.de/documents/ecsa/index.html#_redirect_procedure_protocol_when_consuming_courselinks}
\bibitem{specHashComputing} FreeIT.de, ECSA Documentation, \textit{Computing message digest for courselink redirects}, \url{http://freeit.de/documents/ecsa/index.html#_courselinks}
\bibitem{specBoehMaharaMoodle} David Boehringer, TIK, Uni Stuttgart, \textit{Mahara and Moodle Specification Version 03}
\bibitem{eppn} \url{http://middleware.internet2.edu/eduperson/}
\bibitem{SchacPersonalUniqueCode} \url{http://www.terena.org/activities/tf-emc2/schacreleases.html}
\bibitem{moodleECSmockups} Theo Seemann, TIK, Uni Stuttgart, \textit{LMS admin mockups}, \url{http://FreeIT.de/pub/\_moodle\_ecs\_en.pdf}
\end{thebibliography}

\end{document}
